# Target cursor entities

scoreboard players operation #local chess.id = @s chess.id
execute as @e[type=block_display,tag=chess_cursor] if score @s chess.id = #local chess.id run tag @s add target







# Spawn cursor

execute unless entity @e[type=block_display,tag=chess_cursor,tag=target,limit=1] run summon block_display ~ 512 ~ {Tags:["chess_cursor","target"],Passengers:[{id:"minecraft:item_display",glow_color_override:11141120,brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:31}}}]}







# Raycast cursor

execute anchored eyes positioned ^ ^ ^ run function chess:cursor/raycast







# Assign cursor color

scoreboard players set #cursor_color chess.value 0

execute at @e[type=block_display,tag=chess_cursor,tag=target,limit=1] if block ~ 63 ~ #chess:board positioned ~ 64 ~ if entity @e[type=block_display,tag=chess_piece,tag=friend,distance=..0.5] run scoreboard players set #cursor_color chess.value 1
execute if score #cursor_mode chess.value matches 2 at @e[type=block_display,tag=chess_cursor,tag=target,limit=1] if block ~ 63 ~ #chess:selection run scoreboard players set #cursor_color chess.value 1

execute if score #cursor_color chess.value matches 0 as @e[type=block_display,tag=chess_cursor,tag=target,limit=1] on passengers run data merge entity @s {glow_color_override:11141120}
execute if score #cursor_color chess.value matches 1 as @e[type=block_display,tag=chess_cursor,tag=target,limit=1] on passengers run data merge entity @s {glow_color_override:170}







# Assign cursor glowing

scoreboard players set #cursor_glowing chess.value 0

execute at @e[type=block_display,tag=chess_cursor,tag=target,limit=1] if block ~ 63 ~ #chess:board run scoreboard players set #cursor_glowing chess.value 1
execute as @e[type=block_display,tag=chess_cursor,tag=target,limit=1] on passengers store result entity @s Glowing byte 1 run scoreboard players get #cursor_glowing chess.value







# Play click noise

execute if score @s chess.use_item matches 1.. run playsound ui.button.click master @s







# Piece selection

execute if score @s chess.use_item matches 1.. if score #cursor_mode chess.value matches 2 at @e[type=block_display,tag=chess_cursor,tag=target,limit=1] unless block ~ 63 ~ #chess:selection positioned ~ 64 ~ run function chess:cursor/deselect
execute if score @s chess.use_item matches 1.. if score #cursor_mode chess.value matches 1 if score #cursor_color chess.value matches 1 at @e[type=block_display,tag=chess_cursor,tag=target,limit=1] positioned ~ 64 ~ run function chess:cursor/select







# Move piece

execute if score @s chess.use_item matches 1.. if score #cursor_mode chess.value matches 2 at @e[type=block_display,tag=chess_cursor,tag=target,limit=1] if block ~ 63 ~ #chess:selection positioned ~ 64 ~ as @e[type=block_display,tag=chess_piece,tag=selected,limit=1] run function chess:cursor/move/main







# Choose promotion

execute if score @s chess.use_item matches 1.. if score #cursor_mode chess.value matches 3 if score #cursor_color chess.value matches 1 at @e[type=block_display,tag=chess_cursor,tag=target,limit=1] positioned ~ 64 ~ run function chess:cursor/promotion







# Push mode value

scoreboard players operation #cursor_mode chess.value = #cursor_mode_update chess.value







# Assign ID values

scoreboard players operation @e[type=block_display,tag=chess_cursor,tag=target] chess.id = @s chess.id







# Remove tags

tag @e[type=block_display,tag=chess_cursor] remove target